/*=========================================================================

 Program:   BlueBerry Platform
 Language:  C++
 Date:      $Date: 2010-01-16 19:57:43 +0100 (Sat, 16 Jan 2010) $
 Version:   $Revision: 21070 $

 Copyright (c) German Cancer Research Center, Division of Medical and
 Biological Informatics. All rights reserved.
 See MITKCopyright.txt or http://www.mitk.org/copyright.html for details.

 This software is distributed WITHOUT ANY WARRANTY; without even
 the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 PURPOSE.  See the above copyright notices for more information.

 =========================================================================*/

#include "berryIStateListener.h"

#include "berryState.h"

namespace berry {

void
IStateListener::Events
::AddListener(IStateListener::Pointer l)
{
  if (l.IsNull()) return;

  stateChanged += Delegate(l.GetPointer(), &IStateListener::HandleStateChange);
}

void
IStateListener::Events
::RemoveListener(IStateListener::Pointer l)
{
  if (l.IsNull()) return;

  stateChanged -= Delegate(l.GetPointer(), &IStateListener::HandleStateChange);
}

}


