/*=========================================================================

 Program:   Medical Imaging & Interaction Toolkit
 Language:  C++
 Date:      $Date: 2010-03-26 18:30:16 +0100 (Fri, 26 Mar 2010) $
 Version:   $Revision: 21934 $

 Copyright (c) German Cancer Research Center, Division of Medical and
 Biological Informatics. All rights reserved.
 See MITKCopyright.txt or http://www.mitk.org/copyright.html for details.

 This software is distributed WITHOUT ANY WARRANTY; without even
 the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 PURPOSE.  See the above copyright notices for more information.

 =========================================================================*/


#ifndef QMITKMOCKFUNCTIONALITY_H_
#define QMITKMOCKFUNCTIONALITY_H_

#include <QmitkFunctionality.h>

#include <util/berryCallHistory.h>

class QmitkMockFunctionality : public QmitkFunctionality
{
public:

  berryObjectMacro(QmitkMockFunctionality)

  static const std::string ID; // = "org.mitk.gui.qt.common.tests.api.MockFunctionality";

  QmitkMockFunctionality();

  ~QmitkMockFunctionality();

  berry::CallHistory::Pointer GetCallHistory() const;

  void SetFocus();

protected:

  void CreateQtPartControl(QWidget* parent);

private:

  berry::CallHistory::Pointer callTrace;
};

#endif /* QMITKMOCKFUNCTIONALITY_H_ */
