/*=========================================================================
 
Program:   Medical Imaging & Interaction Toolkit
Language:  C++
Date:      $Date: 2010-09-26 20:40:25 +0200 (Sun, 26 Sep 2010) $
Version:   $Revision: 26363 $
 
Copyright (c) German Cancer Research Center, Division of Medical and
Biological Informatics. All rights reserved.
See MITKCopyright.txt or http://www.mitk.org/copyright.html for details.
 
This software is distributed WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the above copyright notices for more information.
 
=========================================================================*/

#ifndef _MITK_POINT_DATA_VTK_MAPPER_3D__H_
#define _MITK_POINT_DATA_VTK_MAPPER_3D__H_

#include <mitkVtkMapper3D.h>
#include "MitkExtExports.h"
#include "mitkPointData.h"
#include "vtkCellArray.h"
#include "vtkFloatArray.h"
#include "vtkPointData.h"
#include "vtkPoints.h"
#include "vtkPolyData.h"
#include "vtkPolyDataMapper.h"
#include "vtkRenderWindow.h"
#include "vtkRenderWindowInteractor.h"
#include "vtkRenderer.h"


class vtkActor;
class vtkPolyDataMapper;
class vtkSphereSource;
class vtkPolyData;
class vtkPoints;
class vtkCellArray;

namespace mitk
{

class MitkExt_EXPORT PointDataVtkMapper3D : public VtkMapper3D
{
public:

    mitkClassMacro( PointDataVtkMapper3D, VtkMapper3D );

    itkNewMacro( Self );

    itkSetMacro( Radius, float);

    itkGetMacro( Radius, float);
    
    virtual vtkProp* GetVtkProp(mitk::BaseRenderer* renderer);

protected:

    PointDataVtkMapper3D();

    virtual ~PointDataVtkMapper3D();

    virtual void GenerateData();

    vtkActor* m_PointActor;

    vtkPolyDataMapper* m_PointMapper;

    vtkPolyData* m_PolyData;
    vtkPoints* m_Points;
    vtkCellArray* m_CellArray;

    float m_Radius;
};


} //namespace mitk


#endif


